---
title: 'ARIA: rowgroup role'
slug: Web/Accessibility/ARIA/Roles/Rowgroup_Role
tags:
  - ARIA
  - HTML
  - Rôles
  - rowgroup
  - table
---
<div>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</div>

<p>An element with <code>role="rowgroup"</code> is a group of <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Row_Role">rows</a> within a tabular structure. A <code>rowgroup</code> contains one or more rows of <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Cell_Role">cells</a>,  <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Gridcell_Role">grid cells</a>, <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Columnheader_Role">column headers</a>, or <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/rowheader_Role">row headers</a> within a <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">grid</a></code>, <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Table_Role">table</a></code> or <code><a class="new" href="/en-US/docs/Web/Accessibility/ARIA/Roles/Treegrid_Role" rel="nofollow">treegrid</a></code>.</p>

<pre class="brush: html">&lt;div role="table" aria-label="Populations" aria-describedby="country_population_desc"&gt;
   &lt;div id="country_population_desc"&gt;World Populations by Country&lt;/div&gt;
   &lt;div role="rowgroup"&gt;
      &lt;div role="row"&gt;
         &lt;span role="columnheader" aria-sort="descending"&gt;Country&lt;/span&gt;
         &lt;span role="columnheader"aria-sort="none"&gt;Population&lt;/span&gt;
      &lt;/div&gt;
   &lt;/div&gt;
   &lt;div role="rowgroup"&gt;
     &lt;div role="row"&gt;
        &lt;span role="cell"&gt;Finland&lt;/span&gt;
        &lt;span role="cell"&gt;5.5 million&lt;/span&gt;
     &lt;/div&gt;
     &lt;div role="row"&gt;
        &lt;span role="cell"&gt;France&lt;/span&gt;
        &lt;span role="cell"&gt;67 million&lt;/span&gt;
     &lt;/div&gt;
  &lt;/div&gt;
&lt;/div&gt;
</pre>

<h2 id="Description">Description</h2>

<p><code>Rowgroup</code> establishes a relationship between owned row elements and is a structural equivalent to the <a href="/en-US/docs/Web/HTML/Element/thead">thead</a>, <a href="/en-US/docs/Web/HTML/Element/tfoot">tfoot </a>and <a href="/en-US/docs/Web/HTML/Element/tbody">tbody </a>elements in HTML. There is, however, no differentiation between different types of rowgroups. Their elements must be contained in, or owned by, elements with either the <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Table_Role">table </a>or <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">grid</a> role. Using the native <a href="/en-US/docs/Web/HTML/Element/thead">&lt;thead&gt;</a>, <a href="/en-US/docs/Web/HTML/Element/tfoot">&lt;tfoot&gt;</a> , and <a href="/en-US/docs/Web/HTML/Element/tbody">&lt;tbody&gt;</a> HTML elements, whenever possible, is strongly encouraged.</p>

<p>To create an ARIA table header, table footer or table body, add <code>role="rowgroup"</code> to the element. That rowgroup should be nested within a grid, table or treegrid, encompassing a group of one or more rows. Each row, in turn, contains child cells. These cells can be of different types, depending on whether they are column or row headers, or plain or grid cells.</p>

<div class="note">
<p>Note: Using the native HTML table element (&lt;table&gt;) along with the table header (&lt;thead&gt;), footer (&lt;tfoot&gt;), and body  (&lt;tbody&gt;) elements whenever possible is strongly encouraged.</p>
</div>

<h3 id="Associated_WAI-ARIA_roles_states_and_properties">Associated WAI-ARIA roles, states, and properties</h3>

<h4 id="Context_roles">Context roles</h4>

<dl>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Table_Role">role="table"</a></dt>
 <dd>One of the three possible contexts (along with grid and treegrid) in which you'll find a row.  It identifies the row as being part of a non-interactive table structure containing data arranged in rows and columns, similar to the native <code><a href="/en-US/docs/Web/HTML/Element/table">&lt;table&gt;</a></code> HTML element. </dd>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">role="grid"</a></dt>
 <dd>One of the three possible contexts (along with table and treegrid) in which you'll find a row. It identifies the row as being part of a non-interactive table structure containing data arranged in rows and columns, similar to the native <code><a href="/en-US/docs/Web/HTML/Element/table">&lt;table&gt;</a></code> HTML element.</dd>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Gridtree_Role">role="treegrid"</a></dt>
 <dd>Similar to a grid, but with rows that can be expanded and collapsed in the same manner as for a tree.</dd>
</dl>

<h4 id="Descendant_roles">Descendant roles</h4>

<dl>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Row_Role">role="row"</a></dt>
 <dd>A row of cells within a tabular structure. A row contains one or more <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Cell_Role">cells</a>,  <a href="/en-US/docs/en-US/docs/Web/Accessibility/ARIA/Roles/Gridcell_Role">gridcell</a>, or <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Columnheader_Role">column headers</a>, and sometimes a <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/rowheader_Role">row header</a>.</dd>
</dl>

<h3 id="Keyboard_interactions">Keyboard interactions</h3>

<p>None</p>

<h3 id="Required_JavaScript_features">Required JavaScript features</h3>

<p>None.</p>

<div class="note">
<p><span class="ILfuVd yZ8quc">The first rule of ARIA use is if you can use a native feature with the semantics and behavior you require already built in, instead of re-purposing an element and <strong>adding</strong> an ARIA role, state or property to make it accessible, then do so. Employ the HTML &lt;table&gt; element instead of the ARIA role of table whenever possible.</span></p>
</div>

<h2 id="Examples">Examples</h2>

<pre class="brush: html">&lt;div role="table" aria-label="Semantic Elements" aria-describedby="semantic_elements_table_desc" aria-rowcount="81"&gt;
  &lt;div id="semantic_elements_table_desc"&gt;Semantic Elements to use instead of ARIA's roles&lt;/div&gt;
  &lt;div role="rowgroup"&gt;
     &lt;div role="row"&gt;
       &lt;span role="columnheader" aria-sort="none"&gt;ARIA Role&lt;/span&gt;
       &lt;span role="columnheader" aria-sort="none"&gt;Semantic Element&lt;/span&gt;
     &lt;/div&gt;
   &lt;/div&gt;
   &lt;div role="rowgroup"&gt;
    &lt;div role="row" aria-rowindex="11"&gt;
       &lt;span role="cell"&gt;header&lt;/span&gt;
       &lt;span role="cell"&gt;h1&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row"  aria-rowindex="16"&gt;
      &lt;span role="cell"&gt;header&lt;/span&gt;
      &lt;span role="cell"&gt;h6&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row"  aria-rowindex="18"&gt;
      &lt;span role="cell"&gt;rowgroup&lt;/span&gt;
      &lt;span role="cell"&gt;thead&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row"  aria-rowindex="24"&gt;
      &lt;span role="cell"&gt;term&lt;/span&gt;
      &lt;span role="cell"&gt;dt&lt;/span&gt;
    &lt;/div&gt;
  &lt;/div&gt;
&lt;/div&gt;
</pre>

<p>The above is a non-semantic ARIA table with a table header and table body, with five of 81 rows present in the DOM: one within a table header and four rows within the table body. The header row, alone in a header rowgroup, has two column headers. The columns are sortable, but not currently sorted, as indicated by the <code>aria-sort</code> property. The table body is a separate rowgroup, with four rows currently in the DOM. Because not all the rows are in the DOM, we've included the <code>aria-rowindex</code> property on every row.</p>

<h2 id="Best_practices">Best practices</h2>

<p>Only use table, tbody, thead, tr, th, td, and so on for data table structure. You can add these ARIA roles to ensure accessibility should the native semantics of the table be removed, such as with CSS. A relevant use case for the ARIA table role is when the CSS's display property overrides the native semantics of a table, such as by <code>display: grid</code>. In this case, you can use the ARIA table roles to add in the semantics.</p>

<pre class="brush: html">&lt;table role="table" aria-label="Semantic Elements" aria-describedby="semantic_elements_table_desc" aria-rowcount="81"&gt;
  &lt;caption id="semantic_elements_table_desc"&gt;Semantic Elements to use instead of ARIA's roles&lt;/caption&gt;
  &lt;thead role="rowgroup"&gt;
     &lt;tr role="row"&gt;
       &lt;th role="columnheader" aria-sort="none"&gt;ARIA Role&lt;/th&gt;
       &lt;th role="columnheader" aria-sort="none"&gt;Semantic Element&lt;/th&gt;
     &lt;/tr&gt;
  &lt;/thead&gt;
  &lt;tbody role="rowgroup"&gt;
     &lt;tr role="row" aria-rowindex="11"&gt;
       &lt;td role="cell"&gt;header&lt;/td&gt;
       &lt;td role="cell"&gt;h1&lt;/td&gt;
     &lt;/tr&gt;
     &lt;tr role="row" aria-rowindex="16"&gt;
       &lt;td role="cell"&gt;header&lt;/td&gt;
       &lt;td role="cell"&gt;h6&lt;/td&gt;
     &lt;/tr&gt;
   &lt;/tbody&gt;
 &lt;/table&gt;</pre>

<p>Above is the semantic way of writing a table. The ARIA roles are only necessary if the native semantics of the table, and therefore the table rows, are obliterated, such as by setting the <a href="/en-US/docs/Web/CSS/display#Accessibility_concerns">display property to flex or grid</a>.</p>

<h3 id="Added_benefits">Added benefits</h3>

<p>none</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#rowgroup","ARIA rowgroup role")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTML/Element/table">HTML table </a></li>
 <li><a href="/en-US/docs/Web/HTML/Element/tbody">HTML table body</a></li>
 <li><a href="/en-US/docs/Web/HTML/Element/tfoot">HTML table footer</a></li>
 <li><a href="/en-US/docs/Web/HTML/Element/thead">HTML table header</a></li>
</ul>
